<template>
  <div>
    <v-chip color="blue" :class="{ 'lighten-2': !isCurrentUser }" text-color="white" small v-if="id && user.id">
      <span v-if="isCurrentUser">Ich</span>
      <span v-if="!isCurrentUser">{{ user.forename }} {{ user.lastname }}</span>
    </v-chip>
    <v-chip small v-if="id && !user.id">Lade..</v-chip>
    <v-chip color="red lighten-1" text-color="white" small v-if="!id">Nicht gesetzt</v-chip>
  </div>
</template>

<script>
import HTTP from "../../common/HTTP";
import SessionService from "../../common/Session.service";

export default {
  data() {
    return {
      user: {
        id: null,
        forename: "",
        lastname: "",
      },
    };
  },
  props: ["id"],
  watch: {
    id() {
      this.fetchUser();
    },
  },
  methods: {
    fetchUser() {
      const self = this;
      if (this.id) {
        HTTP.get(`users/${this.id}`).then(({ data }) => {
          Object.assign(self.user, data);
        });
      }
    },
  },
  computed: {
    isCurrentUser() {
      return SessionService.isAuthenticated() && SessionService.getSessionUser().id === this.user.id;
    },
  },
  created() {
    this.fetchUser();
  },
  name: "UserChip",
};
</script>
